/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.groupingbyexample;

import java.util.stream.Collectors;
import java.util.Map;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class GroupingByExample {

    public static void main(String[] args) {

        List<Product> products = List.of(
                new Product(1, "Shirt", 1200.0, "Clothing"),
                new Product(2, "Laptop", 2000.0, "Electronics"),
                new Product(3, "Keyboard", 80.0, "Accesories")
        );

        // Example 1: Grouping by product name
        Map<String, List<Product>> productGroups = products.stream()
                .collect(Collectors.groupingBy(Product::getName));

        // Example 2: Grouping by price category
        Map<String, List<Product>> productByCategory = products.stream()
                .collect(Collectors.groupingBy(Product::getCategory));

        // Example 3: Grouping by price range
        Map<String, List<Product>> priceRangeGroups = products.stream()
                .collect(Collectors.groupingBy(
                        p -> {
                            if (p.getPrice() < 50.0) {
                                return "Cheap";
                            } else if (p.getPrice() < 200.0) {
                                return "Moderate";
                            } else {
                                return "Expensive";
                            }
                        }
                ));
    }
}
