/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.tomapexample;

import java.util.stream.Collectors;
import java.util.Map;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class ToMapExample {

    public static void main(String[] args) {

        List<Product> products = List.of(
                new Product(1, "Shirt", 1200.0, "Clothing"),
                new Product(2, "Laptop", 2000.0, "Electronics"),
                new Product(3, "Keyboard", 80.0, "Accesories")
        );

        // Example 1: Basic usage
        Map<Integer, String> productMap = products.stream().collect(Collectors.toMap(
                Product::getId, // keyMapper
                Product::getName // valueMapper
        ));
        System.out.println(productMap);

        // Example 2: Handling duplicates with merge function
        products = List.of(
                new Product(1, "Shirt", 1200.0, "Clothing"),
                new Product(2, "Laptop", 2000.0, "Electronics"),
                new Product(3, "Keyboard", 80.0, "Accesories"),
                new Product(4, "Laptop", 2500.0, "Electronics") // Duplicate key with different price
        );

        Map<String, Double> productPriceMap = products.stream()
                .collect(Collectors.toMap(Product::getName, Product::getPrice,
                        (existing, replacement) -> existing));
        System.out.println("Product Price Map: " + productPriceMap);

    }
}
